<?php
class WatuPROPoetBridge {
   static function main() {
   	  global $wpdb;
   	  
   	  // select exams
   	  $exams = $wpdb->get_results("SELECT * FROM ".WATUPRO_EXAMS." ORDER BY name");
   	  
   	  // select mailing lists from mailpoet
		  if(!class_exists('WYSIJA') and !function_exists('mailpoet_wp_version_notice')) wp_die("You must activate MailPoet to use this function");	
		  if(class_exists('WYSIJA')) {
		  	  $model_list = WYSIJA::get('list','model');
			  $lists = $model_list->get(array('name','list_id'),array('is_enabled'=>1));		
		  }
		  else {
		  	  $lists = MailPoet\Models\Segment :: getSegmentsWithSubscriberCount();
		  }
			   	  
   	  // add/edit/delete relation
   	  if(!empty($_POST['add']) and check_admin_referer('watupropoet_rule')) {
				// no duplicates		
				$exists = $wpdb->get_var($wpdb->prepare("SELECT id FROM ".WATUPROPOET_RELATIONS."
					WHERE exam_id=%d AND list_id=%s AND grade_id=%d AND required_question_id=%d", 
					$_POST['exam_id'], $_POST['list_id'], $_POST['grade_id'], $_POST['question_id']));   	  	
   	  	
   	  	if(!$exists) {
					$wpdb->query($wpdb->prepare("INSERT INTO ".WATUPROPOET_RELATIONS." SET 
						exam_id = %d, list_id=%s, grade_id=%d, required_question_id=%d, required_question_points=%s", 
						$_POST['exam_id'], $_POST['list_id'], $_POST['grade_id'], $_POST['question_id'], $_POST['points']));
					}   	  
   	  }
   
   		if(!empty($_POST['save']) and check_admin_referer('watupropoet_rule')) {
				$wpdb->query($wpdb->prepare("UPDATE ".WATUPROPOET_RELATIONS." SET 
					exam_id = %d, list_id=%s, grade_id=%d, required_question_id=%d, required_question_points=%s WHERE id=%d", 
					$_POST['exam_id'], $_POST['list_id'], $_POST['grade_id'], $_POST['question_id'], $_POST['points'], $_POST['id']));   	  
   	  }
   	  
			if(!empty($_POST['del']) and check_admin_referer('watupropoet_rule')) {
				$wpdb->query($wpdb->prepare("DELETE FROM ".WATUPROPOET_RELATIONS." WHERE id=%d", $_POST['id']));
			}   	  
   	  
   	  // select existing relations
   	  $relations = $wpdb->get_results("SELECT * FROM ".WATUPROPOET_RELATIONS." ORDER BY id");
   	  
   	  // select all non-category grades and match them to exams and relations
   	  $grades = $wpdb->get_results("SELECT * FROM ".WATUPRO_GRADES." WHERE cat_id=0 ORDER BY gtitle");
   	  
   	  foreach($exams as $cnt=>$exam) {
   	  	  $exam_grades = array();
   	  	  foreach($grades as $grade) {
   	  	  	if($grade->exam_id == $exam->ID) $exam_grades[] = $grade;
			  }
			  
			  $exams[$cnt]->grades = $exam_grades;
   	  }
   	  
   	  foreach($relations as $cnt=>$relation) {
   	  	  $rel_grades = array();
   	  	  foreach($grades as $grade) {
   	  	  	if($grade->exam_id == $relation->exam_id) $rel_grades[] = $grade;
			  }
			  
			  $relations[$cnt]->grades = $rel_grades;
   	  }
   	     	  
   	  include(WATUPROPOET_PATH."/views/main.html.php");
   }

	 // actually subscribe the user
	 static function complete_exam($taking_id) {
	 	  global $wpdb;
	 	  
	 	 if(!class_exists('WYSIJA') and !function_exists('mailpoet_wp_version_notice')) return false;
	 	 
	 	  // select taking		
	 	  $taking = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_TAKEN_EXAMS." 	
	 	  	WHERE ID=%d", $taking_id));
	 	  	
	 	  // if email not available, return false
			if(empty($taking->user_id) and empty($taking->email)) return false;
			
	 	  // see if there are any relations for this exam ID
	 	  $relations = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".WATUPROPOET_RELATIONS." 
		 	  WHERE exam_id=%d", $taking->exam_id));
		 	  
		 	if(!sizeof($relations)) return false;  
		 	 // echo "HERE BRIDGE 2";
	
		$email = $taking->email;
		$name = $taking->name;
		if(empty($email)) {
			$user = get_userdata($taking->user_id);
      	$email = $user->user_email;
      	$name = $user->display_name;
		}
		
		// name still empty? Default to guest although that's not a great idea
		if(empty($name)) $name = 'Guest';
		 $user_data = array(
        'email' => $email,
        'firstname' => $name,
        'lastname' => '');
    	
   	// select mailing lists from mailchimp
   	$list_ids = array();
   	foreach($relations as $relation) {
		  // check grade
		  if(!empty($relation->grade_id) and $relation->grade_id != $taking->grade_id) continue;
		  
   	  // check required question / points if any
   	  if(!empty($relation->required_question_id)) {
   	  	  // selectif  answer of the given question with the desired points exists in THIS taking only
   	  	  $answer_exists = $wpdb->get_var($wpdb->prepare("SELECT ID FROM ".WATUPRO_STUDENT_ANSWERS." 
   	  	  	WHERE taking_id=%d AND question_id=%d AND points=%s", $taking_id, $relation->required_question_id, $relation->required_question_points));
   	  	  if(!$answer_exists) continue;	
		  }
		  
		  $list_ids[] = $relation->list_id;			
		} // end foreach relation	
	
		if(!empty($list_ids)) {
			// finally add the user
			 $data_subscriber = array(
		      'user' => $user_data,
		      'user_list' => array('list_ids' => $list_ids)
		    );
		    
		    if(class_exists('WYSIJA')) {
		    	   $helper_user = WYSIJA::get('user','helper');
    		 		$helper_user->addSubscriber($data_subscriber);
		    }
		    else {
		    	
		    	MailPoet\Models\Subscriber :: subscribe($user_data, $list_ids);
		    }
		}		
		
   } // end complete exam
}