<?php
// main model containing general config and UI functions
class WatuPROPoet {
   static function install() {
   	global $wpdb;	
   	$wpdb -> show_errors();
   	
   	self::init();
	   
    // relations bewteen completed exams and mailing lists. 
    // For now not depending on exam result but place the field for later use
    if($wpdb->get_var("SHOW TABLES LIKE '".WATUPROPOET_RELATIONS."'") != WATUPROPOET_RELATIONS) {  
        $sql = "CREATE TABLE `".WATUPROPOET_RELATIONS."` (
				id int(11) unsigned NOT NULL auto_increment PRIMARY KEY,
				exam_id int(11) unsigned NOT NULL default '0',
				list_id VARCHAR(100) NOT NULL DEFAULT '',
				grade_id int(11) unsigned NOT NULL default '0',
				required_question_id int(11) unsigned NOT NULL default '0',
				required_question_points DECIMAL(8,2) NOT NULL default '0.00'
			) CHARACTER SET utf8;";
        $wpdb->query($sql);         
    	}
	}	   
   
   // main menu
   static function menu() {
   	add_submenu_page('watupro_exams', __('Bridge to MailPoet', 'watupropoet'), __('Bridge to MailPoet', 'watupropoet'), 'manage_options', 
   		'watupropoet', array('WatuPROPoetBridge','main'));	
	}
	
	// CSS and JS
	static function scripts() {   
   	wp_enqueue_script('jquery');
	}
	
	// initialization
	static function init() {
		global $wpdb;
		load_plugin_textdomain( 'watupropoet' );
		define('WATUPROPOET_RELATIONS', $wpdb->prefix.'watupropoet_relations');
		
		add_action('watupro_completed_exam', array('WatuPROPoetBridge', 'complete_exam'));
	}	
}