<div class="wrap">
	<h1><?php _e('WatuPRO to MailPoet Bridge', 'watupropoet')?></h1>
	
	<p><?php _e('This bridge lets you automatically subscribe users who take your exams into selected list in MailPoet.', 'watupropoet')?></p>
	
	<p><?php _e('Note that in order to have quiz taker subscribed you need their email address. So this will work the user is logged or (for non-logged in users) when you have selected to request user email at the start or end of the quiz.','watupropoet')?> </p>
	
   <h2><?php _e('Add New Rule', 'watupropoet')?></h2>	  
	  
	 <form method="post">
	 	<div class="wrap">
	 			<?php _e('When user completes', 'watupropoet')?> <select name="exam_id" onchange="wmChangeQuiz(this.value, 'wbbGradeSelector');">
	 			<option value=""><?php _e('- Select quiz -', 'watupropoet');?></option>
	 			<?php foreach($exams as $exam):?>
	 				<option value="<?php echo $exam->ID?>"><?php echo stripslashes($exam->name)?></option>
	 			<?php endforeach;?>
	 			</select> 
				
				<?php _e('achieving the following grade:', 'watupropoet')?>
				<span id="wbbGradeSelector">
					<select name="grade_id">
					   <option value="0"><?php _e('- Any grade -', 'watupropoet');?></option>
					   <?php foreach($exams[0]->grades as $grade):?>
					   	<option value="<?php echo $grade->ID?>"><?php echo stripslashes($grade->gtitle);?></option>
					   <?php endforeach;?>
					</select>
				</span>				
				
				 			
	 			<?php _e('subscribe them to mailing list','watupropoet')?> 
	 			<select name="list_id">
	 				<option value=""><?php _e('- Select list -', 'watupropoet');?></option>
	 				<?php foreach($lists as $list):?>
	 					<option value="<?php echo $list['list_id']?>"><?php echo stripslashes($list['name']);?></option>
	 				<?php endforeach;?>
	 			</select>
	 			<br />
	 			<?php printf(__('And also require the user to achieve %s points on question #%s (enter question ID)', 'watupropoet'), 
	 				'<input type="text" name="points" size="4">', '<input type="text" size="4" name="question_id">');?>
	 				<a href="#" onclick="jQuery('#explainRequiredQuestion').toggle();return false;"><?php _e("(What's this?)", 'watupropoet');?></a>
	 			<input type="submit" name="add" value="<?php _e('Add Rule', 'watupropoet')?>">
	 				<div id="explainRequiredQuestion" style="display:none;">
	 					<?php _e('Selecting a required question is optional. It lets you specify that user should answer a given question with specific amouint of points, otherwise they will not be subscribed. <b>Use this for example to create a single-choice question asking if they want to subscribe to the mailing list.</b> You will find the question IDs on the Manage Questions page for the selected quiz.', 'watupropoet');?>
	 				</div>
	 			<hr />
	 	</div>
	 	<?php wp_nonce_field('watupropoet_rule');?>
	 </form> 
	 
	 <h2><?php _e('Manage Existing Rules', 'watupropoet')?></h2>
	 <?php if(sizeof($relations)):?>
	 	<?php foreach($relations as $relation):?>
	 	<form method="post">
	 	<input type="hidden" name="id" value="<?php echo $relation->id?>">
	 	<input type="hidden" name="del" value="0">
	 	<div class="wrap">
	 			<?php _e('When user completes', 'watupropoet')?> <select name="exam_id" onchange="wmChangeQuiz(this.value, 'wbbGradeSelector<?php echo $relation->id?>');">
	 			<option value=""><?php _e('- Select quiz -', 'watupropoet');?></option>
	 			<?php foreach($exams as $exam):
	 				$selected = ($exam->ID == $relation->exam_id) ? " selected" : "";?>
	 				<option value="<?php echo $exam->ID?>"<?php echo $selected?>><?php echo stripslashes($exam->name)?></option>
	 			<?php endforeach;?>
	 			</select> 
	 			
				<?php _e('achieving the following grade:', 'watupropoet')?>
				<span id="wbbGradeSelector<?php echo $relation->id?>">
					<select name="grade_id">
					   <option value="0"><?php _e('- Any grade -', 'watupropoet');?></option>
					   <?php foreach($relation->grades as $grade):
					   	$selected = ($grade->ID == $relation->grade_id) ? " selected" : "";?>
					   	<option value="<?php echo $grade->ID?>"<?php echo $selected?>><?php echo stripslashes($grade->gtitle);?></option>
					   <?php endforeach;?>
					</select>
				</span>			
					 			
	 			<?php _e('subscribe them to mailing list','watupropoet')?> 
	 			<select name="list_id">
	 				<option value=""><?php _e('- Select list -', 'watupropoet');?></option>
	 				<?php foreach($lists as $list):
	 					$selected = ($list['list_id'] == $relation->list_id) ? " selected" : "";?>
	 					<option value="<?php echo empty($list['list_id']) ? $list['id'] : $list['list_id']?>"<?php echo $selected?>><?php echo stripslashes($list['name']);?></option>
	 				<?php endforeach;?>
	 			</select>
	 			<br>
	 			<?php printf(__('And also require the user to achieve %s points on question #%s (enter question ID)', 'watupropoet'), 
	 				'<input type="text" name="points" size="4" value="'.$relation->required_question_points.'">', 
	 				'<input type="text" size="4" name="question_id" value="'.$relation->required_question_id.'">');?>
	 			<input type="submit" name="save" value="<?php _e('Save Rule', 'watupropoet')?>">
	 			<input type="button" value="<?php _e('Delete Rule', 'watupropoet')?>" onclick="wmConfirmDelete(this.form);">
	 			<hr />
	 	</div>
	 	<?php wp_nonce_field('watupropoet_rule');?>
	 </form> 
	 	<?php endforeach;?>
	 <?php else:?>
	 <p><?php _e('You have not created any rules yet.', 'watupropoet');?></p>	
	 <?php endif;?>
</div>

<script type="text/javascript" >
function wmConfirmDelete(frm) {
		if(confirm("<?php _e('Are you sure?', 'watupropoet')?>")) {
			frm.del.value=1;
			frm.submit();
		}
}

function wmChangeQuiz(quizID, selectorID) {
	// array containing all grades by exams
	var grades = {<?php foreach($exams as $exam): echo $exam->ID.' : {';
			foreach($exam->grades as $grade):
				echo $grade->ID .' : "'.$grade->gtitle.'",';
			endforeach;
		echo '},';
	endforeach;?>};
	
	// construct the new HTML
	var newHTML = '<select name="grade_id">';
	newHTML += "<option value='0'><?php _e('- Any grade -', 'watupropoet');?></option>";
	jQuery.each(grades, function(i, obj){
		if(i == quizID) {
			jQuery.each(obj, function(j, grade) {
				newHTML += "<option value=" + j + ">" + grade + "</option>\n";
			}); // end each grade
		}
	});
	newHTML += '</select>'; 
	
	jQuery('#'+selectorID).html(newHTML);
}
</script>